indexing 
   description: "Objects with an entry point that the scheduler can call"
   note: ""
   status: "$State: Exp $"
   date: "$Date: 2000/11/01 18:31:42 $"
   revision: "$Revision: 1.5 $"
   author: "Alain Le Guennec"
deferred class ACTIVABLE
feature {ANY} -- Queries

   identity : IDENTITY;

   nb_transitions : INTEGER is
         -- Number of outgoing transitions.
      deferred
      end -- nb_transitions

   labels (n : INTEGER) : STRING is
         -- Labels associated with transitions.
      require
         valid_transition: n > 0 and n <= nb_transitions
      deferred
      end -- labels

   guards (n : INTEGER) : BOOLEAN is
         -- Guards associated with transitions.
      require
         valid_transition: n > 0 and n <= nb_transitions
      deferred
      end -- activable

feature {ANY} -- Commands

   action (n : INTEGER) is
         -- Actions associated with fireable transitions.
      require
         fireable_transition: guards (n)
      deferred
      end -- action

   init_activable (name : STRING) is
      do
         if name /= Void and not name.empty then
            identity.set_out (name);
         end;
      end

end -- class ACTIVABLE
