class CONFIGURATION
inherit ANY redefine out end
creation make
feature {CADP_SIMULATOR}

   hash : INTEGER is
      local
         i : INTEGER
         l : INTEGER
         e : INTEGER
         m : EVENT
         s : STATE_MACHINE
         a : ACTIVE_STATE_MACHINE
      do
         from
            i := process_table.lower
         until
            i >  process_table.upper
         loop
            s ?= process_table.item(i);
            if s /= Void then
               a ?= s;
               if a /= Void then
                  l := a.message_queue.count + 1;
                  if l > 1 then
                     m := a.message_queue.item;
                     c_inline_c("_e=_m->id;");
                  else
                     e := 1;
                  end
               else
                  l := 1;
                  e := 1;
               end;
               c_inline_c("R+=_i*_l*_e*_s->id;");
            end;
            i := i + 1;
         end;
      end -- hash

   out : STRING is
      local
         i : INTEGER
         l : INTEGER
         s : STATE_MACHINE
         a : ACTIVE_STATE_MACHINE
      do
         !!Result.make_from_string ("There are ");
         Result.append(process_table.count.out);
         Result.append(" activable objects:%N")
         from
            i := process_table.lower
         until
            i >  process_table.upper
         loop
            Result.append(i.out);
            Result.append("->");
            Result.append(process_table.item(i).generating_type);
            Result.append("%N");
            s ?= process_table.item(i);
            if s /= Void then
               a ?= s
               if a /= Void then
                  Result.append(a.message_queue.out);
               end
            end;
            i := i + 1;
         end;
      end -- out

   make is
      do
	 !!process_table.make(1,0) 
--	 process_table.put(manager,1) -- add the TIME_MANAGER Singleton to it
      end

   register (new_process: ACTIVABLE) is
	 -- register a new process to manage
      require
         not_void: new_process /= Void
      do
	 process_table.add_last(new_process)
      end -- register

   process_table : ARRAY[ACTIVABLE]

end -- CONFIGURATION
