indexing 
   description: "Something that can be received by a REACTIVE object"
   note: ""
   status: "$State: Exp $"
   date: "$Date: 2000/11/01 18:31:42 $"
   revision: "$Revision: 1.8 $"
   author: "Alain Le Guennec"
deferred class EVENT
inherit
   ANY
      redefine
         out
   end
feature {ANY}  -- creation
   make (new_arguments: ARRAY[ANY]) is
         -- set the message parameters
      do
         arguments := new_arguments -- should deep_clone?
      end -- make
feature {ANY}
   send_to (target: ANY) is
      require
         target_not_void: target /= Void
      local
         reactive : REACTIVE;
      do
         reactive ?= target;
         if reactive /= Void then
            reactive.receive(Current);
         else
--            dispatch_to(target);
         end;
      end -- send_to 

   dispatch_to (target : ANY) is deferred end;

   event_name : STRING is deferred end;

   out, label : STRING is
      do
         Result := label_for_arguments;
--         Result.extend(')');
--         Result.prepend("(");
         Result.prepend(event_name);
      end;

feature {NONE}

   label_for_arguments : STRING is
      local
         arg : INTEGER;
         act : ACTIVABLE
      do
         !!Result.make(100);
         if arguments /= Void and then arguments.count > 0 then
            Result.extend('(');
            from
               arg := arguments.lower
            until
               arg = arguments.upper
            loop
               act ?= arguments.item(arg);
               if act /= Void then
                  Result.append(act.identity.out);
               else
--                  Result.extend('[');
                  Result.append(arguments.item(arg).tagged_out);
--                  Result.extend(']');
               end;
               Result.extend(',');
               arg := arg + 1;
            end;
            act ?= arguments.last;
            if act /= Void then
               Result.append(act.identity.out);
            else
               Result.append(arguments.last.out);
            end;
            Result.extend(')');
         end;
      end;

feature {ANY} -- Queries
   arguments : ARRAY[ANY]
end -- class EVENT
