indexing 
   description: "Bottom of a protocol stack"
   note: ""
   status: "$State: Exp $"
   date: "$Date: 2000/01/17 14:59:46 $"
   revision: "$Revision: 1.3 $"
   author: "Jean-Marc Jezequel"
class PORT
inherit
   REACTIVE
   ACTIVABLE
creation
   initialize
feature
   initialize is
         -- Setup the initial step of this Protocol Entity
      do
         !!fifo.make(1,0)
      end -- initialize

feature {ANY} -- Queries

   server : ANY

feature {ANY} -- Commands

   connect (new_server: like server) is
         -- set a new server 
      do 
         server := new_server
      ensure
         connected: server = new_server
      end -- connect

   receive (e : EVENT) is
         -- receive an event and queue it to simulate latency.
      do
         enqueue(e)
      end -- receive

feature {NONE}

   enqueue (e : EVENT) is
         -- enqueue an event comming from a proxy.
      require
         e_not_void: e /= Void
      do
         fifo.put(e)
      end -- enqueue

feature {CADP_SIMULATOR}

   nb_transitions : INTEGER is
      do
         if not fifo.empty then
            Result := 1
         else
            Result := 0
         end -- if
      end -- nb_transitions

   labels (n : INTEGER): STRING is
      do
         Result := fifo.item.label
      end -- labels

   guards (n : INTEGER) : BOOLEAN is
      do
         Result := True
      end -- guards

   action (n : INTEGER) is
         -- Unqueue message in the fifo and pass it to the upper layer.
      do
         fifo.item.send_to(server);
         fifo.remove
      end -- action

feature {NONE}

   fifo : LINKED_QUEUE[EVENT]
         -- located at the arrival port, to model the network latency
invariant
   fifo_not_void: fifo /= Void
end -- class PORT
